Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trdtrc.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trdtrc.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/TRP/trdtrc.F90	(revision 10302)
@@ -19,4 +19,7 @@
    USE trdmxl_trc        ! Mixed layer trends diag.
    USE iom               ! I/O library
+# if defined key_debug_medusa
+   USE trcstat,          ONLY: trc_rst_dia_stat     
+# endif
 
    IMPLICIT NONE
@@ -86,21 +89,70 @@
 
       IF( lk_trdtrc .AND. ln_trdtrc( kjn ) ) THEN
-         !
+      !! JPALM -- 17-08-2017 -- modif following trd_tra_iom as suggested by Georges
+      !!                     -- add jptra_tot; jptra_totad; jptra_zdfp
+      !!                     -- shange to output trends every 2 time-step, except tot.
+      !!                     -- move cltra and iomput inside the select case
+      !!                     So if an non-wanted case arrives here it will not go
+      !!                     through cltra (without value) and break iomput.
+      !!                     -- Add iom_use in prevision of not using All trends
+      !!                     for All passive tracers (will create a HUGE 3D file otherwise --
+      !!                     might be interested in very few of them : SMS and TOT probably)
+         !
+         SELECT CASE( ktrd )
+         !! tot - output every time-step:
+         CASE( jptra_tot  )       ;    WRITE (cltra,'("TOT_",4a)')
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
+         END SELECT
+         !
+       IF( MOD( kt, 2 ) == 0 ) THEN
          SELECT CASE( ktrd )
          CASE( jptra_xad  )       ;    WRITE (cltra,'("XAD_",4a)')
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
          CASE( jptra_yad  )       ;    WRITE (cltra,'("YAD_",4a)')
-         CASE( jptra_zad  )       ;    WRITE (cltra,'("ZAD_",4a)')
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
+         CASE( jptra_zad  )       ;    WRITE (cltra,'("ZAD_",4a)')      !! care vvl case
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
+         CASE( jptra_totad  )     ;    WRITE (cltra,'("TAD_",4a)')      !! total adv
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
          CASE( jptra_ldf  )       ;    WRITE (cltra,'("LDF_",4a)')
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
          CASE( jptra_bbl  )       ;    WRITE (cltra,'("BBL_",4a)')
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
          CASE( jptra_nsr  )       ;    WRITE (cltra,'("FOR_",4a)')
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
          CASE( jptra_zdf  )       ;    WRITE (cltra,'("ZDF_",4a)')
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
+         CASE( jptra_zdfp )       ;    WRITE (cltra,'("ZDP_",4a)')
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
          CASE( jptra_dmp  )       ;    WRITE (cltra,'("DMP_",4a)')
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
          CASE( jptra_sms  )       ;    WRITE (cltra,'("SMS_",4a)')
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
+         CASE( jptra_radb )       ;    WRITE (cltra,'("RDB_",4a)')
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
+         CASE( jptra_radn )       ;    WRITE (cltra,'("RDN_",4a)')
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
+         END SELECT
+       ELSE IF( MOD( kt, 2 ) == 1 ) THEN
+         SELECT CASE( ktrd )
          CASE( jptra_atf  )       ;    WRITE (cltra,'("ATF_",4a)')
-         CASE( jptra_radb )       ;    WRITE (cltra,'("RDB_",4a)')
-         CASE( jptra_radn )       ;    WRITE (cltra,'("RDN_",4a)')
-         END SELECT
-                                          cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
-                                          CALL iom_put( cltra,  ptrtrd(:,:,:) )
+                           cltra = TRIM(cltra)//TRIM(ctrcnm(kjn))
+                           CALL trd_trc_iomput( cltra, ptrtrd, kjn, kt )
+         END SELECT
+       END IF
          !
       END IF
@@ -123,4 +175,33 @@
 
    END SUBROUTINE trd_trc_bio
+
+   SUBROUTINE trd_trc_iomput( cltra, ptrtrd, kjn, kt )
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trd_trc_iomput  ***
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT( in )  ::   kt                                  ! timestep
+      INTEGER, INTENT( in )  ::   kjn                                 ! biotrend index
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout )  ::   ptrtrd  ! var trend
+      CHARACTER (len=*),INTENT( in ) :: cltra                         ! trend name
+      !!----------------------------------------------------------------------
+
+
+      IF  (iom_use(cltra)) THEN
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) ' TREND stats (min, max,sum) kt = ',kt ,' jn = ',kjn
+         CALL trc_rst_dia_stat( ptrtrd(:,:,1), cltra)
+# endif
+         CALL iom_put( cltra,  ptrtrd(:,:,:) )
+# if defined key_debug_medusa
+      ELSE
+         IF(lwp) WRITE(numout,*) &
+                      ' TREND -- No output asked for ',cltra,' kt = ',kt,' jn = ',kjn
+         CALL trc_rst_dia_stat( ptrtrd(:,:,1), cltra)
+# endif
+      ENDIF
+
+   END SUBROUTINE trd_trc_iomput
+
+
 #else
    !!----------------------------------------------------------------------
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 10302)
@@ -33,4 +33,9 @@
    !! --------------------------------------------------
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)               ::  trai           !: initial total tracer
+# if defined key_medusa && key_roam 
+   !! AXY (17/11/2017): elemental cycle initial totals
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)               ::  cycletot       !: initial elemental cycle total
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:)               ::  cycletot2      !: initial elemental cycle total excl. halo in mpp_sum
+# endif
    REAL(wp), PUBLIC                                                ::  areatot        !: total volume 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:  )         ::  cvol           !: volume correction -degrad option- 
@@ -105,5 +110,5 @@
    END TYPE DIAG
 
-#if defined key_medusa && defined key_iomput
+#if defined key_medusa
    TYPE, PUBLIC :: BDIAG
       LOGICAL              :: dgsave
@@ -134,4 +139,6 @@
                   OCN_KWCO2, OCN_K0, CO2STARAIR, OCN_DPCO2,                                          & ! end of regular 2D
                   TPP3, DETFLUX3, REMIN3N, PH3, OM_CAL3,                                             & ! end of regular 3D
+! JPALM (01/09/17): additional UKESM 2D diag
+                  CHL_MLD, CHL_CPL,                                                                  &
 ! AXY (11/11/16): additional CMIP6 2D diagnostics
                   epC100, epCALC100, epN100, epSI100,                                                &
@@ -264,4 +271,7 @@
          &      cvol(jpi,jpj,jpk)     , rdttrc(jpk)           , trai(jptra)           ,       &
          &      ctrcnm(jptra)         , ctrcln(jptra)         , ctrcun(jptra)         ,       & 
+# if defined key_medusa && defined key_roam
+         &      cycletot(6), cycletot2(6)                                             ,       &
+# endif
          &      ln_trc_ini(jptra)     , ln_trc_wri(jptra)     , qsr_mean(jpi,jpj)     ,  STAT = trc_alloc  )  
 
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 10302)
@@ -28,4 +28,5 @@
    USE trcini_idtra    ! idealize tracer initialisation
    USE trcini_medusa   ! MEDUSA   initialisation
+   USE par_medusa      ! MEDUSA   parameters (needed for elemental cycles)
    USE trcdta          ! initialisation from files
    USE daymod          ! calendar manager
@@ -35,5 +36,7 @@
    USE sbc_oce
    USE trcice          ! tracers in sea ice
- 
+# if defined key_medusa
+   USE sms_medusa      ! MEDUSA   initialisation
+# endif
    IMPLICIT NONE
    PRIVATE
@@ -62,5 +65,13 @@
       !!                or read data or analytical formulation
       !!---------------------------------------------------------------------
-      INTEGER ::   jk, jn, jl    ! dummy loop indices
+      INTEGER ::   ji, jj, jk, jn, jl    ! dummy loop indices
+# if defined key_medusa && defined key_roam
+      !! AXY (23/11/2017)
+      REAL(wp)                         :: zsum3d, zsum2d
+      REAL(wp)                         :: zq1, zq2, loc_vol, loc_area
+      REAL(wp), DIMENSION(6)           :: loc_cycletot3, loc_cycletot2
+      REAL(wp), DIMENSION(jpi,jpj,jpk) :: ztot3d
+      REAL(wp), DIMENSION(jpi,jpj)     :: ztot2d, carea
+# endif
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
@@ -98,4 +109,7 @@
       !                                                              ! total volume of the ocean 
       areatot = glob_sum( cvol(:,:,:) )
+# if defined key_medusa && defined key_roam
+      carea(:,:) = e1e2t(:,:) * tmask(:,:,1) 
+# endif
 
       IF( lk_pisces  )       CALL trc_ini_pisces       ! PISCES  bio-model
@@ -192,8 +206,83 @@
       ENDIF
 
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'trc_init : passive tracer set up completed'
-      IF(lwp) WRITE(numout,*) '~~~~~~~'
-      IF(lwp) CALL flush(numout)
+# if defined key_medusa && defined key_roam
+      ! AXY (17/11/2017): calculate initial totals of elemental cycles
+      !
+      ! This is done in a very hard-wired way here; in future, this could be
+      ! replaced with loops and using a 2D array; one dimension would cover
+      ! the tracers, the other would be for the elements; each tracer would
+      ! have a factor for each element to say how much of that element was
+      ! in that tracer; for example, PHN would be 1.0 for N, xrfn for Fe and
+      ! xthetapn for C, with the other elements 0.0; the array entry for PHN
+      ! would then be (1. 0. xrfn xthetapn 0. 0.) for (N, Si, Fe, C, A, O2);
+      ! saving this for the next iteration
+      !
+      cycletot(:) = 0._wp
+      ! report elemental totals at initialisation as we go along
+      IF ( lwp ) WRITE(numout,*)
+      IF ( lwp ) WRITE(numout,*)    ' Elemental cycle totals: '
+      ! nitrogen
+      ztot3d(:,:,:) = trn(:,:,:,jpphn) + trn(:,:,:,jpphd) + trn(:,:,:,jpzmi) + &
+                      trn(:,:,:,jpzme) + trn(:,:,:,jpdet) + trn(:,:,:,jpdin)
+      ztot2d(:,:)   = zn_sed_n(:,:)
+      zsum3d        = glob_sum( ztot3d(:,:,:) * cvol(:,:,:) )
+      zsum2d        = glob_sum( ztot2d(:,:) * carea(:,:) )
+      cycletot(1)   = zsum3d + zsum2d
+      IF ( lwp ) WRITE(numout,9010) 'nitrogen', zsum3d, zsum2d, cycletot(1)
+      ! silicon
+      ztot3d(:,:,:) = trn(:,:,:,jppds) + trn(:,:,:,jpsil)
+      ztot2d(:,:)   = zn_sed_si(:,:)
+      zsum3d        = glob_sum( ztot3d(:,:,:) * cvol(:,:,:) )
+      zsum2d        = glob_sum( ztot2d(:,:) * carea(:,:) )
+      cycletot(2)   = zsum3d + zsum2d
+      IF ( lwp ) WRITE(numout,9010) 'silicon', zsum3d, zsum2d, cycletot(2)
+      ! iron
+      ztot3d(:,:,:) = ((trn(:,:,:,jpphn) + trn(:,:,:,jpphd) + trn(:,:,:,jpzmi) + &
+                      trn(:,:,:,jpzme) + trn(:,:,:,jpdet)) * xrfn) + trn(:,:,:,jpfer)
+      ztot2d(:,:)   = zn_sed_fe(:,:)
+      zsum3d        = glob_sum( ztot3d(:,:,:) * cvol(:,:,:) )
+      zsum2d        = glob_sum( ztot2d(:,:) * carea(:,:) )
+      cycletot(3)   = zsum3d + zsum2d
+      IF ( lwp ) WRITE(numout,9010) 'iron', zsum3d, zsum2d, cycletot(3)
+      ! carbon (uses fixed C:N ratios on plankton tracers)
+      ztot3d(:,:,:) = (trn(:,:,:,jpphn) * xthetapn)  + (trn(:,:,:,jpphd) * xthetapd)  +  &
+                      (trn(:,:,:,jpzmi) * xthetazmi) + (trn(:,:,:,jpzme) * xthetazme) +  &
+                      trn(:,:,:,jpdtc) + trn(:,:,:,jpdic)
+      ztot2d(:,:)   = zn_sed_c(:,:) + zn_sed_ca(:,:)
+      zsum3d        = glob_sum( ztot3d(:,:,:) * cvol(:,:,:) )
+      zsum2d        = glob_sum( ztot2d(:,:) * carea(:,:) )
+      cycletot(4)   = zsum3d + zsum2d
+      IF ( lwp ) WRITE(numout,9010) 'carbon', zsum3d, zsum2d, cycletot(4)
+      ! alkalinity (note benthic correction)
+      ztot3d(:,:,:) = trn(:,:,:,jpalk)
+      ztot2d(:,:)   = zn_sed_ca(:,:) * 2._wp
+      zsum3d        = glob_sum( ztot3d(:,:,:) * cvol(:,:,:) )
+      zsum2d        = glob_sum( ztot2d(:,:) * carea(:,:) )
+      cycletot(5)   = zsum3d + zsum2d
+      IF ( lwp ) WRITE(numout,9010) 'alkalinity', zsum3d, zsum2d, cycletot(5)
+      ! oxygen (note no benthic)
+      ztot3d(:,:,:) = trn(:,:,:,jpoxy)
+      ztot2d(:,:)   = 0._wp
+      zsum3d        = glob_sum( ztot3d(:,:,:) * cvol(:,:,:) )
+      zsum2d        = glob_sum( ztot2d(:,:) * carea(:,:) )
+      cycletot(6)   = zsum3d + zsum2d
+      IF ( lwp ) WRITE(numout,9010) 'oxygen', zsum3d, zsum2d, cycletot(6)
+      ! Check
+      zsum3d        = glob_sum( cvol(:,:,:) )
+      zsum2d        = glob_sum( carea(:,:) )      
+      IF ( lwp ) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) ' check : cvol    : ', zsum3d
+         WRITE(numout,*) ' check : carea   : ', zsum2d
+         WRITE(numout,*)
+      ENDIF
+      !
+# endif
+
+      IF(lwp) THEN 
+          WRITE(numout,*)
+          WRITE(numout,*) 'trc_init : passive tracer set up completed'
+          WRITE(numout,*) '~~~~~~~'
+      ENDIF 
 # if defined key_debug_medusa
          CALL trc_rst_stat
@@ -202,4 +291,7 @@
 
 9000  FORMAT(' tracer nb : ',i2,'      name :',a10,'      initial content :',e18.10)
+9010  FORMAT(' element:',a10,                     &
+             ' 3d sum:',e18.10,' 2d sum:',e18.10, &
+             ' total:',e18.10)
       !
       IF( nn_timing == 1 )   CALL timing_stop('trc_init')
Index: branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/trcnam.F90
===================================================================
--- branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 9287)
+++ branches/UKMO/dev_r5518_GO6_package_FOAMv14/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 10302)
@@ -60,5 +60,16 @@
       !!                ( (PISCES, CFC, MY_TRC, MEDUSA, IDTRA, Age )
       !!---------------------------------------------------------------------
-      INTEGER  ::   jn, jk                     ! dummy loop indice
+      INTEGER ::  ierr
+#if defined key_trdmxl_trc  || defined key_trdtrc
+      NAMELIST/namtrc_trd/ nn_trd_trc, nn_ctls_trc, rn_ucf_trc, &
+         &                ln_trdmxl_trc_restart, ln_trdmxl_trc_instant, &
+         &                cn_trdrst_trc_in, cn_trdrst_trc_out, ln_trdtrc
+#endif
+
+      INTEGER  ::   jn, jk              ! dummy loop indice
+      INTEGER  ::   ios                 ! Local integer output status for namelist read
+      !!---------------------------------------------------------------------
+
+
       !                                        !   Parameters of the run 
       IF( .NOT. lk_offline ) CALL trc_nam_run
@@ -68,5 +79,5 @@
       
       !                                        !   Parameters of additional diagnostics
-      CALL trc_nam_dia
+      IF( .NOT. lk_iomput )  CALL trc_nam_dia
 
       !                                        !   namelist of transport
@@ -171,6 +182,6 @@
       ENDIF
 
-      IF( lk_c14b     ) THEN   ;   CALL trc_nam_c14b         ! C14 bomb     tracers
-      ELSE                    ;   IF(lwp) WRITE(numout,*) '          C14 not used'
+      IF( lk_c14b    ) THEN  ;   CALL trc_nam_c14b         ! C14 bomb     tracers
+      ELSE                   ;   IF(lwp) WRITE(numout,*) '          C14 not used'
       ENDIF
 
